<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/AVSCommon/Utils/include/AVSCommon/Utils/SDS/Writer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_13e65effb2bde530b17b3d5eefcd0266.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_49dd3d9ac5586189aa170bac46425b9c.html">Utils</a></li><li class="navelem"><a class="el" href="dir_957fc395b73dfe8b64ee3f74464f588a.html">include</a></li><li class="navelem"><a class="el" href="dir_ced5fe410515ed61d81f9a22ef3eef03.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_ee116be5d1129358ffaec72096859541.html">Utils</a></li><li class="navelem"><a class="el" href="dir_67f252838b28d15e64579aa37f54606c.html">SDS</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Writer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_writer_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_SDS_WRITER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_SDS_WRITER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;cstdint&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;cstddef&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;limits&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;cstring&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_logger_utils_8h.html">AVSCommon/Utils/Logger/LoggerUtils.h</a>&quot;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_shared_data_stream_8h.html">SharedDataStream.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_writer_policy_8h.html">WriterPolicy.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">namespace </span>avsCommon {</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">namespace </span>utils {</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">namespace </span>sds {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html">   46</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream</a>&lt;T&gt;::<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html">Writer</a> {</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#ae48b9c21cf40e11557a14f8335540083">   49</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">Policy</a> = <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">WriterPolicy</a>;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error.html">   56</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error.html">Error</a> {</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keyword">enum</span> {</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error.html#a1a695a8fd023e70c564773c3887d301f">   59</a></span>&#160;            CLOSED = 0,</div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error.html#a1310ae23a2ffea22b830d64ac75c0727">   61</a></span>&#160;            WOULDBLOCK = -1,</div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error.html#aa73e7b9cd8dc4e07ee68619437eac866">   63</a></span>&#160;            INVALID = -2,</div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error.html#a4bcec261ed8aaf4c428f4adfbe892aa8">   65</a></span>&#160;            TIMEDOUT = -3,</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        };</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    };</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html">Writer</a>(Policy policy, std::shared_ptr&lt;BufferLayout&gt; bufferLayout);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    ~<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html">Writer</a>();</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    ssize_t write(<span class="keyword">const</span> <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> nWords, std::chrono::milliseconds timeout = std::chrono::milliseconds(0));</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#a6b73c95dbde8b184f8b3176ff9a3f3f1">Index</a> tell() <span class="keyword">const</span>;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keywordtype">void</span> close();</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#addf921de1c499680a30c33a501f2a44f">getWordSize</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="keyword">static</span> std::string errorToString(Error error);</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> std::string TAG;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    Policy m_policy;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    std::shared_ptr&lt;BufferLayout&gt; m_bufferLayout;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordtype">bool</span> m_closed;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;};</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="keyword">const</span> std::string <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">SharedDataStream&lt;T&gt;::Writer::TAG</a> = <span class="stringliteral">&quot;SdsWriter&quot;</span>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00151"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a214685a81a45f48842ed22556b852a29">  151</a></span>&#160;<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a214685a81a45f48842ed22556b852a29">SharedDataStream&lt;T&gt;::Writer::Writer</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">Policy</a> policy, std::shared_ptr&lt;BufferLayout&gt; bufferLayout) :</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        m_policy{policy},</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        m_bufferLayout{bufferLayout},</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        m_closed{<span class="keyword">false</span>} {</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <span class="comment">// Note - SharedDataStream::createWriter() holds writerEnableMutex while calling this function.</span></div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="keyword">auto</span> header = m_bufferLayout-&gt;getHeader();</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    header-&gt;isWriterEnabled = <span class="keyword">true</span>;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    header-&gt;writeEndCursor = header-&gt;writeStartCursor.load();</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;}</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00162"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a23385a745233b3c1872e619e1e2fa05c">  162</a></span>&#160;<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a23385a745233b3c1872e619e1e2fa05c">SharedDataStream&lt;T&gt;::Writer::~Writer</a>() {</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    close();</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;}</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a5fbe6db4c4932cdc947ac5f742802b6e">  167</a></span>&#160;ssize_t <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a5fbe6db4c4932cdc947ac5f742802b6e">SharedDataStream&lt;T&gt;::Writer::write</a>(<span class="keyword">const</span> <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> nWords, std::chrono::milliseconds timeout) {</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <span class="keywordflow">if</span> (<span class="keyword">nullptr</span> == buf) {</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">logger::acsdkError</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">logger::LogEntry</a>(TAG, <span class="stringliteral">&quot;writeFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;nullBuffer&quot;</span>));</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordflow">return</span> Error::INVALID;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    }</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="keywordflow">if</span> (0 == nWords) {</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">logger::acsdkError</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">logger::LogEntry</a>(TAG, <span class="stringliteral">&quot;writeFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;zeroNumWords&quot;</span>));</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keywordflow">return</span> Error::INVALID;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    }</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="keyword">auto</span> header = m_bufferLayout-&gt;getHeader();</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="keywordflow">if</span> (!header-&gt;isWriterEnabled) {</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">logger::acsdkError</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">logger::LogEntry</a>(TAG, <span class="stringliteral">&quot;writeFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;writerDisabled&quot;</span>));</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keywordflow">return</span> Error::CLOSED;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    }</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="keyword">auto</span> wordsToCopy = nWords;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keyword">auto</span> buf8 = <span class="keyword">static_cast&lt;</span><span class="keyword">const </span>uint8_t*<span class="keyword">&gt;</span>(buf);</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    std::unique_lock&lt;Mutex&gt; backwardSeekLock(header-&gt;backwardSeekMutex, std::defer_lock);</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#a6b73c95dbde8b184f8b3176ff9a3f3f1">Index</a> writeEnd = header-&gt;writeStartCursor + nWords;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    <span class="keywordflow">switch</span> (m_policy) {</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5ad834d04fd76eafde1c8b4f6f95bdfdf8">Policy::NONBLOCKABLE</a>:</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            <span class="comment">// For NONBLOCKABLE, we can truncate the write if it won&#39;t fit in the buffer.</span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            <span class="keywordflow">if</span> (nWords &gt; m_bufferLayout-&gt;getDataSize()) {</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                wordsToCopy = nWords = m_bufferLayout-&gt;getDataSize();</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                writeEnd = header-&gt;writeStartCursor + nWords;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            }</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5a5d027622828a53a8fc66dd131952c8a1">Policy::ALL_OR_NOTHING</a>:</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            <span class="comment">// For ALL_OR_NOTHING, we can&#39;t overwrite readers, and we can&#39;t truncate, but we might be able to discard</span></div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;            <span class="comment">// bytes that overflow if oldestUnconsumedCursor is in the future (e.g. there are readers waiting for future</span></div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            <span class="comment">// data which has not been written yet).</span></div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            <span class="comment">// Note - this check must be performed while locked to prevent a reader from backwards-seeking into the</span></div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;            <span class="comment">// write region between here and the writeEndCursor update below.</span></div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;            backwardSeekLock.lock();</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;            <span class="keywordflow">if</span> ((writeEnd &gt;= header-&gt;oldestUnconsumedCursor) &amp;&amp;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;                ((writeEnd - header-&gt;oldestUnconsumedCursor) &gt; m_bufferLayout-&gt;getDataSize())) {</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;                <span class="keywordflow">return</span> Error::WOULDBLOCK;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            }</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="keywordflow">case</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4ba72323e5457d8fb855145bfee934aa415">Policy::BLOCKING</a>:</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            <span class="comment">// For BLOCKING, we need to wait until there is room for at least one word.</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            <span class="comment">// Condition for returning from write: there is space for a write.</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            <span class="keyword">auto</span> predicate = [<span class="keyword">this</span>, header] {</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;                <span class="keywordflow">return</span> (header-&gt;writeStartCursor &lt; header-&gt;oldestUnconsumedCursor) ||</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;                       (header-&gt;writeStartCursor - header-&gt;oldestUnconsumedCursor) &lt; m_bufferLayout-&gt;getDataSize();</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            };</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            <span class="comment">// Note - this check must be performed while locked to prevent a reader from backwards-seeking into the</span></div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;            <span class="comment">// write region between here and the writeEndCursor update below.</span></div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;            backwardSeekLock.lock();</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;            <span class="comment">// Wait for space to become available.</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;            <span class="keywordflow">if</span> (std::chrono::milliseconds::zero() == timeout) {</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                header-&gt;spaceAvailableConditionVariable.wait(backwardSeekLock, predicate);</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!header-&gt;spaceAvailableConditionVariable.wait_for(backwardSeekLock, timeout, predicate)) {</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                <span class="keywordflow">return</span> Error::TIMEDOUT;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            }</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            <span class="comment">// Figure out how much space we have.</span></div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;            <span class="keyword">auto</span> spaceAvailable = m_bufferLayout-&gt;getDataSize();</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;            <span class="keywordflow">if</span> (header-&gt;writeStartCursor &gt;= header-&gt;oldestUnconsumedCursor) {</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;                <span class="keyword">auto</span> wordsToOverrun =</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;                    m_bufferLayout-&gt;getDataSize() - (header-&gt;writeStartCursor - header-&gt;oldestUnconsumedCursor);</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;                <span class="keywordflow">if</span> (wordsToOverrun &lt; spaceAvailable) {</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;                    spaceAvailable = wordsToOverrun;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;                }</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;            }</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            <span class="comment">// For BLOCKING, we can truncate the write if it won&#39;t fit in the buffer.</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            <span class="keywordflow">if</span> (spaceAvailable &lt; nWords) {</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                wordsToCopy = nWords = spaceAvailable;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;                writeEnd = header-&gt;writeStartCursor + nWords;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            }</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;            <span class="keywordflow">break</span>;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    }</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    header-&gt;writeEndCursor = writeEnd;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <span class="comment">// We&#39;ve updated our end cursor, so we no longer need to hold off backward seeks.</span></div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <span class="keywordflow">if</span> (backwardSeekLock) {</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        backwardSeekLock.unlock();</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    }</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    <span class="keywordflow">if</span> (<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5a5d027622828a53a8fc66dd131952c8a1">Policy::ALL_OR_NOTHING</a> == m_policy) {</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        <span class="comment">// If we have more data than the SDS can hold and we&#39;re not going to be overwriting oldestUnconsumedCursor, we</span></div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="comment">// can safely discard the initial data and just leave the trailing data in the buffer.</span></div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        <span class="keywordflow">if</span> (wordsToCopy &gt; m_bufferLayout-&gt;getDataSize()) {</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;            wordsToCopy = m_bufferLayout-&gt;getDataSize();</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;            buf8 += (nWords - wordsToCopy) * <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#addf921de1c499680a30c33a501f2a44f">getWordSize</a>();</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        }</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    }</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <span class="comment">// Split it across the wrap.</span></div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="keywordtype">size_t</span> beforeWrap = m_bufferLayout-&gt;wordsUntilWrap(header-&gt;writeStartCursor);</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="keywordflow">if</span> (beforeWrap &gt; wordsToCopy) {</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        beforeWrap = wordsToCopy;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    }</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    <span class="keywordtype">size_t</span> afterWrap = wordsToCopy - beforeWrap;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    <span class="comment">// Copy the two segments.</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    memcpy(m_bufferLayout-&gt;getData(header-&gt;writeStartCursor), buf8, beforeWrap * <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#addf921de1c499680a30c33a501f2a44f">getWordSize</a>());</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="keywordflow">if</span> (afterWrap &gt; 0) {</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        memcpy(</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            m_bufferLayout-&gt;getData(header-&gt;writeStartCursor + beforeWrap),</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            buf8 + beforeWrap * <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#addf921de1c499680a30c33a501f2a44f">getWordSize</a>(),</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            afterWrap * <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#addf921de1c499680a30c33a501f2a44f">getWordSize</a>());</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    }</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    <span class="comment">// Advance the write cursor.</span></div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    <span class="comment">// Note: To prevent a race condition and ensure that readers which block on dataAvailableConditionVariable don&#39;t</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    <span class="comment">// miss a notify, we should always lock the dataAvailableConditionVariable mutex while moving writeStartCursor.  As</span></div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="comment">// an optimization, we skip that lock for NONBLOCKABLE writers under the assumption that they will be writing</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <span class="comment">// continuously, so a missed notification is not significant.</span></div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <span class="comment">// Note: As a further optimization, the lock could be omitted if no blocking readers are in use (ACSDK-251).</span></div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    std::unique_lock&lt;Mutex&gt; dataAvailableLock(header-&gt;dataAvailableMutex, std::defer_lock);</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordflow">if</span> (<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5ad834d04fd76eafde1c8b4f6f95bdfdf8">Policy::NONBLOCKABLE</a> != m_policy) {</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        dataAvailableLock.lock();</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    }</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    header-&gt;writeStartCursor = header-&gt;writeEndCursor.load();</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <span class="keywordflow">if</span> (<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5ad834d04fd76eafde1c8b4f6f95bdfdf8">Policy::NONBLOCKABLE</a> != m_policy) {</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        dataAvailableLock.unlock();</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    }</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="comment">// Notify the reader(s).</span></div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    <span class="comment">// Note: as an optimization, we could skip this if there are no blocking readers (ACSDK-251).</span></div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    header-&gt;dataAvailableConditionVariable.notify_all();</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <span class="keywordflow">return</span> nWords;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;}</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00303"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#adb294ffcac9d766147c307b62edc1929">  303</a></span>&#160;<span class="keyword">typename</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#a6b73c95dbde8b184f8b3176ff9a3f3f1">SharedDataStream&lt;T&gt;::Index</a> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#adb294ffcac9d766147c307b62edc1929">SharedDataStream&lt;T&gt;::Writer::tell</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    <span class="keywordflow">return</span> m_bufferLayout-&gt;getHeader()-&gt;writeStartCursor;</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;}</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00308"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a843b9440e8865bd4d272ea49a11b2c4c">  308</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a843b9440e8865bd4d272ea49a11b2c4c">SharedDataStream&lt;T&gt;::Writer::close</a>() {</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    <span class="keyword">auto</span> header = m_bufferLayout-&gt;getHeader();</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    std::lock_guard&lt;Mutex&gt; lock(header-&gt;writerEnableMutex);</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    <span class="keywordflow">if</span> (m_closed) {</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    }</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    <span class="keywordflow">if</span> (header-&gt;isWriterEnabled) {</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        header-&gt;isWriterEnabled = <span class="keyword">false</span>;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        std::unique_lock&lt;Mutex&gt; dataAvailableLock(header-&gt;dataAvailableMutex);</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        header-&gt;hasWriterBeenClosed = <span class="keyword">true</span>;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        header-&gt;dataAvailableConditionVariable.notify_all();</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    }</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    m_closed = <span class="keyword">true</span>;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;}</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00327"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#ab113ddefa849b32678d1b8ce55a25c20">  327</a></span>&#160;<span class="keywordtype">size_t</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#ab113ddefa849b32678d1b8ce55a25c20">SharedDataStream&lt;T&gt;::Writer::getWordSize</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    <span class="keywordflow">return</span> m_bufferLayout-&gt;getHeader()-&gt;wordSize;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;}</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00332"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#afd4da7f29e3d8f724533fbd0435bbbe7">  332</a></span>&#160;std::string <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#afd4da7f29e3d8f724533fbd0435bbbe7">SharedDataStream&lt;T&gt;::Writer::errorToString</a>(<a class="code" href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error.html">Error</a> error) {</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    <span class="keywordflow">switch</span> (error) {</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;        <span class="keywordflow">case</span> Error::CLOSED:</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;CLOSED&quot;</span>;</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;        <span class="keywordflow">case</span> Error::WOULDBLOCK:</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;WOULDBLOCK&quot;</span>;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        <span class="keywordflow">case</span> Error::INVALID:</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;INVALID&quot;</span>;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;        <span class="keywordflow">case</span> Error::TIMEDOUT:</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;TIMEDOUT&quot;</span>;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    }</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">logger::acsdkError</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">logger::LogEntry</a>(TAG, <span class="stringliteral">&quot;errorToStringFailed&quot;</span>).d(<span class="stringliteral">&quot;reason&quot;</span>, <span class="stringliteral">&quot;invalidError&quot;</span>).d(<span class="stringliteral">&quot;error&quot;</span>, error));</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    <span class="keywordflow">return</span> <span class="stringliteral">&quot;(unknown error &quot;</span> + to_string(error) + <span class="stringliteral">&quot;)&quot;</span>;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;}</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;}  <span class="comment">// namespace sds</span></div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;}  <span class="comment">// namespace utils</span></div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;}  <span class="comment">// namespace avsCommon</span></div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_SDS_WRITER_H_</span></div><div class="ttc" id="_writer_policy_8h_html"><div class="ttname"><a href="_writer_policy_8h.html">WriterPolicy.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_html_a214685a81a45f48842ed22556b852a29"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a214685a81a45f48842ed22556b852a29">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer::Writer</a></div><div class="ttdeci">Writer(Policy policy, std::shared_ptr&lt; BufferLayout &gt; bufferLayout)</div><div class="ttdef"><b>Definition:</b> Writer.h:151</div></div>
<div class="ttc" id="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error_html"><div class="ttname"><a href="structalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_1_1_error.html">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer::Error</a></div><div class="ttdef"><b>Definition:</b> Writer.h:56</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_html_a5fbe6db4c4932cdc947ac5f742802b6e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a5fbe6db4c4932cdc947ac5f742802b6e">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer::write</a></div><div class="ttdeci">ssize_t write(const void *buf, size_t nWords, std::chrono::milliseconds timeout=std::chrono::milliseconds(0))</div><div class="ttdef"><b>Definition:</b> Writer.h:167</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_html_a7b17d768f16a6f5da766df780d94bbd5"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">alexaClientSDK::avsCommon::utils::sds::WriterPolicy</a></div><div class="ttdeci">WriterPolicy</div><div class="ttdoc">Specifies the policy to use for writing to the stream. </div><div class="ttdef"><b>Definition:</b> WriterPolicy.h:25</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_html_a7b17d768f16a6f5da766df780d94bbd5ad834d04fd76eafde1c8b4f6f95bdfdf8"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5ad834d04fd76eafde1c8b4f6f95bdfdf8">alexaClientSDK::avsCommon::utils::sds::WriterPolicy::NONBLOCKABLE</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_html_a7b17d768f16a6f5da766df780d94bbd5a5d027622828a53a8fc66dd131952c8a1"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5a5d027622828a53a8fc66dd131952c8a1">alexaClientSDK::avsCommon::utils::sds::WriterPolicy::ALL_OR_NOTHING</a></div></div>
<div class="ttc" id="_shared_data_stream_8h_html"><div class="ttname"><a href="_shared_data_stream_8h.html">SharedDataStream.h</a></div></div>
<div class="ttc" id="_logger_utils_8h_html"><div class="ttname"><a href="_logger_utils_8h.html">LoggerUtils.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_html_a23385a745233b3c1872e619e1e2fa05c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a23385a745233b3c1872e619e1e2fa05c">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer::~Writer</a></div><div class="ttdeci">~Writer()</div><div class="ttdoc">This destructor detaches the Writer from a BufferLayout. </div><div class="ttdef"><b>Definition:</b> Writer.h:162</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_html_ab113ddefa849b32678d1b8ce55a25c20"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#ab113ddefa849b32678d1b8ce55a25c20">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer::getWordSize</a></div><div class="ttdeci">size_t getWordSize() const</div><div class="ttdef"><b>Definition:</b> Writer.h:327</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_html_afd4da7f29e3d8f724533fbd0435bbbe7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#afd4da7f29e3d8f724533fbd0435bbbe7">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer::errorToString</a></div><div class="ttdeci">static std::string errorToString(Error error)</div><div class="ttdef"><b>Definition:</b> Writer.h:332</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html">alexaClientSDK::avsCommon::utils::sds::SharedDataStream</a></div><div class="ttdef"><b>Definition:</b> SharedDataStream.h:94</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer</a></div><div class="ttdef"><b>Definition:</b> Writer.h:46</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_html_adb294ffcac9d766147c307b62edc1929"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#adb294ffcac9d766147c307b62edc1929">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer::tell</a></div><div class="ttdeci">Index tell() const</div><div class="ttdef"><b>Definition:</b> Writer.h:303</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_html_a2a506c9c75542fad6d29643e3e3cf55d"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger.html#a2a506c9c75542fad6d29643e3e3cf55d">alexaClientSDK::avsCommon::utils::logger::acsdkError</a></div><div class="ttdeci">void acsdkError(const LogEntry &amp;entry)</div><div class="ttdef"><b>Definition:</b> LoggerUtils.cpp:80</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_html_a07d2a9441f40d089a1f9a0d7e2baab4ba72323e5457d8fb855145bfee934aa415"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4ba72323e5457d8fb855145bfee934aa415">alexaClientSDK::avsCommon::utils::sds::ReaderPolicy::BLOCKING</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_html_addf921de1c499680a30c33a501f2a44f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#addf921de1c499680a30c33a501f2a44f">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::getWordSize</a></div><div class="ttdeci">size_t getWordSize() const</div><div class="ttdef"><b>Definition:</b> SharedDataStream.h:373</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_html_a6b73c95dbde8b184f8b3176ff9a3f3f1"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream.html#a6b73c95dbde8b184f8b3176ff9a3f3f1">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Index</a></div><div class="ttdeci">uint64_t Index</div><div class="ttdef"><b>Definition:</b> SharedDataStream.h:105</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a></div><div class="ttdoc">LogEntry is used to compile the log entry text to log via Logger. </div><div class="ttdef"><b>Definition:</b> LogEntry.h:30</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer_html_a843b9440e8865bd4d272ea49a11b2c4c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html#a843b9440e8865bd4d272ea49a11b2c4c">alexaClientSDK::avsCommon::utils::sds::SharedDataStream::Writer::close</a></div><div class="ttdeci">void close()</div><div class="ttdef"><b>Definition:</b> Writer.h:308</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
